﻿using FellowOakDicom;
using FellowOakDicom.Imaging;
using Microsoft.Extensions.DependencyInjection;
using Microsoft.Extensions.Logging;

namespace IRaCIS.Core.API
{
    public static class DicomSetup
    {
        public static void AddDicomSetup(this IServiceCollection services)
        {
            new DicomSetupBuilder()
            .RegisterServices(s => s.AddFellowOakDicom().AddLogging(config => config.AddConsole())
            .AddTranscoderManager<FellowOakDicom.Imaging.NativeCodec.NativeTranscoderManager>()
            //.AddImageManager<ImageSharpImageManager>()
            )
            .SkipValidation()
            .Build();


        }
    }
}
