﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace IRaCIS.Application.Contracts
{

    public class SCUBasicInfo
    {
        public string? PatientID { get; set; }

        public string? PatientName { get; set; }

        public string? PatientSex { get; set; }

        public string PatientBirthDate { get; set; }

        public string? StudyID { get; set; }

        public string? Modality { get; set; }


        public string? AccessionNumber { get; set; }

        public string? StudyDate { get; set; }

        public string? StudyTime { get; set; }

        public string? BodyPartExamined { get; set; }

        public string? StudyDescription { get; set; }

        public string? StudyInstanceUID { get; set; }
    }
    public class SCUQuery : SCUBasicInfo
    {
        [NotDefault]
        public Guid PacsDicomAEId { get; set; }


        public Guid? TrialId { get; set; }

        public List<string>? ModalitiesInStudyList { get; set; }
    }

    public class SCUCmoveCommand
    {
        [NotDefault]
        public Guid PacsDicomAEId { get; set; }

        public List<string> StudyInstanceUIDList { get; set; }
    }

    public class SCUStudyView : SCUBasicInfo
    {
        public bool IsStudyExist { get; set; }

        public string? ModalitiesInStudy { get; set; }

    }

    public class TJCmoveStudyCommand
    {
        public string Token { get; set; }

        /// <summary>
        /// C-move 检查 数组
        /// </summary>
        public List<string> StudyInstanceUIDList { get; set; }

        /// <summary>
        ///PacsAE 的名字
        /// </summary>
        public  string CalledAE { get; set; }
    }
}
