﻿namespace IRaCIS.Core.Domain.Models;

[Comment("机构 - 医院")]
[Table("Hospital")]
public class Hospital : BaseFullAuditEntity
{
    #region 导航属性
    [JsonIgnore]
    [ForeignKey("SiteId")]
    public Site Site { get; set; }

    [JsonIgnore]
    public List<Doctor> DoctorList { get; set; }
    #endregion
    public string HospitalName { get; set; } = string.Empty;
    public string UniversityAffiliated { get; set; } = string.Empty;
    public string Country { get; set; } = string.Empty;
    public string Province { get; set; } = string.Empty;
    public string City { get; set; } = string.Empty;

    public string HospitalNameCN { get; set; } = string.Empty;
    public string UniversityAffiliatedCN { get; set; } = string.Empty;
    public string CountryCN { get; set; } = string.Empty;
    public string ProvinceCN { get; set; } = string.Empty;
    public string CityCN { get; set; } = string.Empty;
    [Comment("中心Id")]
    public Guid? SiteId { get; set; } = Guid.Empty;
}


public class HIRHospital : BaseFullAuditEntity
{
    public string HospitalName { get; set; }
    public string HospitalAliasName { get; set; }
    public string Country { get; set; }
    public string City { get; set; }
    public string Province { get; set; }
    public string Address { get; set; }
    public string Phone { get; set; }

    public bool IsCanConnectInternet { get; set; }

    public string HospitalCode { get; set; }
    public string HospitalLogoPath { get; set; }
    public int TrialKeepCount { get; set; }

    public bool IsDefault { get; set; }
}