﻿using System;
using Microsoft.EntityFrameworkCore.Migrations;

#nullable disable

namespace IRaCIS.Core.Infra.EFCore.Migrations
{
    /// <inheritdoc />
    public partial class hirAddHospital : Migration
    {
        /// <inheritdoc />
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_DicomInstance_DicomStudy_StudyId",
                table: "DicomInstance");

            migrationBuilder.DropForeignKey(
                name: "FK_TaskInstance_TaskStudy_StudyId",
                table: "TaskInstance");

            migrationBuilder.AddColumn<Guid>(
                name: "TaskStudySeqId",
                table: "TaskInstance",
                type: "uniqueidentifier",
                nullable: true);

            migrationBuilder.CreateIndex(
                name: "IX_TaskInstance_TaskStudySeqId",
                table: "TaskInstance",
                column: "TaskStudySeqId");

            migrationBuilder.AddForeignKey(
                name: "FK_DicomInstance_DicomStudy_StudyId",
                table: "DicomInstance",
                column: "StudyId",
                principalTable: "DicomStudy",
                principalColumn: "Id",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_TaskInstance_TaskStudy_StudyId",
                table: "TaskInstance",
                column: "StudyId",
                principalTable: "TaskStudy",
                principalColumn: "Id",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_TaskInstance_TaskStudy_TaskStudySeqId",
                table: "TaskInstance",
                column: "TaskStudySeqId",
                principalTable: "TaskStudy",
                principalColumn: "SeqId");
        }

        /// <inheritdoc />
        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_DicomInstance_DicomStudy_StudyId",
                table: "DicomInstance");

            migrationBuilder.DropForeignKey(
                name: "FK_TaskInstance_TaskStudy_StudyId",
                table: "TaskInstance");

            migrationBuilder.DropForeignKey(
                name: "FK_TaskInstance_TaskStudy_TaskStudySeqId",
                table: "TaskInstance");

            migrationBuilder.DropIndex(
                name: "IX_TaskInstance_TaskStudySeqId",
                table: "TaskInstance");

            migrationBuilder.DropColumn(
                name: "TaskStudySeqId",
                table: "TaskInstance");

            migrationBuilder.AddForeignKey(
                name: "FK_DicomInstance_DicomStudy_StudyId",
                table: "DicomInstance",
                column: "StudyId",
                principalTable: "DicomStudy",
                principalColumn: "SeqId",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_TaskInstance_TaskStudy_StudyId",
                table: "TaskInstance",
                column: "StudyId",
                principalTable: "TaskStudy",
                principalColumn: "SeqId",
                onDelete: ReferentialAction.Cascade);
        }
    }
}
